# HG changeset patch
# User Felipe G. Nievinski <fgnievinski@gmail.com>
# Date 1428209682 10800
#      Sun Apr 05 01:54:42 2015 -0300
# Node ID 05d75f81b390b0c53aa0e4820af6bbf53b722c31
# Parent  cf9b94a89620cefbd2eb55ac242286252b69ef51
Add comments for translators.

diff -r cf9b94a89620 -r 05d75f81b390 libgui/src/files-dock-widget.cc
--- a/libgui/src/files-dock-widget.cc	Thu Apr 02 15:36:38 2015 -0700
+++ b/libgui/src/files-dock-widget.cc	Sun Apr 05 01:54:42 2015 -0300
@@ -200,6 +200,7 @@
   _file_tree_view->setSortingEnabled (true);
   _file_tree_view->setAlternatingRowColors (true);
   _file_tree_view->setAnimated (true);
+  // TRANSLATOR Activate means open file in the editor or open directory in file browser.
   _file_tree_view->setToolTip (
     tr ("Activate to open in editor, right click for alternatives"));
 
@@ -883,7 +884,7 @@
   bool ok;
 
   QString name = QInputDialog::getText (this, tr ("Create Directory"),
-                tr ("Create folder in\n","String ends with \\n!") + parent_dir,
+                tr ("Create directory in\n","String ends with \\n!") + parent_dir,
                 QLineEdit::Normal, tr ("New Directory"), &ok);
   if (ok && name.length () > 0)
     {
diff -r cf9b94a89620 -r 05d75f81b390 libgui/src/m-editor/file-editor-tab.cc
--- a/libgui/src/m-editor/file-editor-tab.cc	Thu Apr 02 15:36:38 2015 -0700
+++ b/libgui/src/m-editor/file-editor-tab.cc	Sun Apr 05 01:54:42 2015 -0300
@@ -89,6 +89,7 @@
   _status_bar = new QStatusBar (this);
 
   // eol mode
+  // TRANSLATOR: eol stands for end-of-line.
   QLabel *eol_label = new QLabel (tr ("eol:"), this);
   _eol_indicator = new QLabel ("",this);
   QFontMetrics fm = eol_label->fontMetrics ();
diff -r cf9b94a89620 -r 05d75f81b390 libgui/src/settings-dialog.ui
--- a/libgui/src/settings-dialog.ui	Thu Apr 02 15:36:38 2015 -0700
+++ b/libgui/src/settings-dialog.ui	Sun Apr 05 01:54:42 2015 -0300
@@ -677,7 +677,7 @@
                   <item row="0" column="0">
                    <widget class="QLabel" name="editor_lbl_min_tab_width">
                     <property name="text">
-                     <string>Tab width min.</string>
+                     <string extracomment="here tab is a panel tab not the key nor the character">Tab width min.</string>
                     </property>
                    </widget>
                   </item>
@@ -775,7 +775,7 @@
                    <string>This works well for monospaced fonts. The line is drawn at a position based on the width of a space character in the default font. It may not work very well if styles use proportional fonts or if varied font sizes or bold, italic and normal texts are used.</string>
                   </property>
                   <property name="text">
-                   <string>Draw a long line marker</string>
+                   <string extracomment="Right margin vertical guide">Draw a long line marker</string>
                   </property>
                   <property name="checked">
                    <bool>true</bool>
diff -r cf9b94a89620 -r 05d75f81b390 libgui/src/shortcut-manager.cc
--- a/libgui/src/shortcut-manager.cc	Thu Apr 02 15:36:38 2015 -0700
+++ b/libgui/src/shortcut-manager.cc	Sun Apr 05 01:54:42 2015 -0300
@@ -283,6 +283,7 @@
   init (tr ("Show Line Endings"), "editor_view:show_eol_chars", QKeySequence ());
   init (tr ("Show Indentation Guides"), "editor_view:show_ind_guides",
         QKeySequence ());
+  // TRANSLATOR Right margin vertical guide.
   init (tr ("Show Long Line Marker"), "editor_view:show_long_line",
         QKeySequence ());
   init (tr ("Zoom In"), "editor_view:zoom_in", QKeySequence::ZoomIn);
@@ -519,6 +520,7 @@
 
       QVBoxLayout *box = new QVBoxLayout(_dialog);
 
+      // TRANSLATOR Not to be confused with mouse right-click.
       QLabel *help = new QLabel (tr ("Apply the desired shortcut or click "
                                      "on the right button to reset the "
                                      "shortcut to its default."));
@@ -544,6 +546,7 @@
       grid->addWidget (def, 1, 0);
       grid->addWidget (_label_default, 1, 1);
 
+      // TRANSLATOR Not to be confused with 'Set as default'
       QPushButton *set_default = new QPushButton (tr ("Set to default"));
       grid->addWidget (set_default, 0, 2);
       connect (set_default, SIGNAL (clicked ()),